<template>
  <div id="app" class="min-h-100f">
    <!-- <Navbar /> -->
    <router-view v-if="!fetching"/>
    <PopupContainer show class="bg" v-else>
      <div>
        <v-icon name="fire" scale="2" class="nothing"/>
        <p v-if="fetchingError">{{fetchingError}}</p>
      </div>
    </PopupContainer>
  </div>
</template>

<script>
import '@/assets/style.css';
import PopupContainer from '@/components/PopupContainer.vue';
import axios from 'axios';

export default {
  data: () => ({
    fetching: true,
    fetchingError: null,
  }),
  components: {
    PopupContainer,
  },
  methods: {
    getUser() {
      this.fetching = true;
      this.$store.dispatch('getUser')
        .then(() => { this.fetching = false; })
        .catch((err) => {
          if (err.response && err.response.status == 503) {
            // Retry request after 10s
            this.fetchingError = 'Having trouble contacting the server, hang tight.';
            setTimeout(() => this.getUser(), 10000);
          }
          else if (err.response && err.response.status == 401) {
            this.$store.dispatch('logout');
            window.location = '/welcome';
          }
          else if (err.response)
            this.fetchingError = err.response.data.error;
          else
            err;
        });
    },
  },
  mounted() {
    // Load socket.io. The reason for this approach is so that the same code
    // works on development and production
    let sc = document.createElement('script');
    sc.setAttribute('src', `${axios.defaults.baseURL}/socket.io/socket.io.js`);
    sc.defer = true;
    document.head.appendChild(sc);

    if (this.$store.state.logged) {
      this.getUser();
    } else {
      this.fetching = false;
    }
  },
};
</script>

<style scoped>
@keyframes Anim {
  from { transform: scale(1.3); }
}

.bg {
  background:
    linear-gradient(to top right, var(--color-orange), var(--color-primary))
    !important;
  color: white;

  position: fixed;

  width: 100%;
  height: 100%;
}

.bg .fa-icon {
  animation: Anim 2s linear infinite;
}
</style>
